﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.Threading.Tasks

Namespace SelectedItemsBindingDemo
	Public Class PersonModel
		Implements INotifyPropertyChanged

		Private _Ischecked As Boolean
		Public Property Ischecked() As Boolean
			Get
				Return _Ischecked
			End Get
			Set(ByVal value As Boolean)
				_Ischecked = value
				RaisePropertyChanged("Ischecked")
			End Set
		End Property
		Private _summary As String
		Public Property Summary() As String
			Get
				Return _summary
			End Get
			Private Set(ByVal value As String)
				_summary = value
				RaisePropertyChanged("Summary")
			End Set
		End Property
        'INSTANT VB NOTE: The variable selectedItem was renamed since Visual Basic does not allow class members with the same name:
        Private selectedItem_Renamed As Object
        Public Property SelectedItem() As Object
            Get
                Return selectedItem_Renamed
            End Get
            Set(ByVal value As Object)
                selectedItem_Renamed = value
                RaisePropertyChanged("SelectedItem")
            End Set
        End Property
        Public Sub New()
			Me.GDCSource = Getsource()

		End Sub

		Private _gdcsource As ObservableCollection(Of Person)
		Public Property GDCSource() As ObservableCollection(Of Person)
			Get
				Return _gdcsource
			End Get
			Set(ByVal value As ObservableCollection(Of Person))
				_gdcsource = value
			End Set
		End Property
		Private Function Getsource() As ObservableCollection(Of Person)
			Dim items As New ObservableCollection(Of Person)()
			If items IsNot Nothing Then
				items.Add(New Person() With {.FirstName = "Sean", .LastName = "Jacobson", .Age = 23, .Salary = 1999, .GrandTotal = 898908, .PF = 8798798, .ESI = 2498, .Tax = 4298, .Income = 2389, .Company = "SF", .Loss = 880, .Profit = 880980, .TrunOver = 48193891, .Incometax = 234113, .Expense = 98798798, .Payslip = 8789, .Unitprice = 987, .Stockdetails = "Avial", .StockCount = 8989, .Count = 43})
				items.Add(New Person() With {.FirstName = "Srithar", .LastName = "Phyllis", .Age = 24, .Salary = 12349, .GrandTotal = 234923408, .PF = 8798798, .ESI = 423598, .Tax = 568, .Income = 289, .Company = "WP", .Loss = 450, .Profit = 54580, .TrunOver = 28193891, .Incometax = 2113, .Expense = 1798798, .Payslip = 68789, .Unitprice = 8798, .Stockdetails = "Avial", .StockCount = 4389, .Count = 83})
				items.Add(New Person() With {.FirstName = "Marvin", .LastName = "Allen", .Age = 26, .Salary = 123499, .GrandTotal = 123495508, .PF = 88798, .ESI = 345348, .Tax = 55398, .Income = 4489, .Company = "TC", .Loss = 250, .Profit = 234423, .TrunOver = 2448193891, .Incometax = 78124, .Expense = 9879814, .Payslip = 458789, .Unitprice = 798, .Stockdetails = "Avial", .StockCount = 8966, .Count = 89})
				items.Add(New Person() With {.FirstName = "Michael", .LastName = "Allen", .Age = 23, .Salary = 1999, .GrandTotal = 898908, .PF = 8798798, .ESI = 2498, .Tax = 4298, .Income = 2389, .Company = "SF", .Loss = 880, .Profit = 880980, .TrunOver = 48193891, .Incometax = 234113, .Expense = 98798798, .Payslip = 8789, .Unitprice = 987, .Stockdetails = "Avial", .StockCount = 8989, .Count = 43})
				items.Add(New Person() With {.FirstName = "Cecil", .LastName = "Allison", .Age = 24, .Salary = 12349, .GrandTotal = 234923408, .PF = 8798798, .ESI = 423598, .Tax = 568, .Income = 289, .Company = "WP", .Loss = 450, .Profit = 54580, .TrunOver = 28193891, .Incometax = 2113, .Expense = 1798798, .Payslip = 68789, .Unitprice = 8798, .Stockdetails = "Avial", .StockCount = 4389, .Count = 83})
				items.Add(New Person() With {.FirstName = "Oscar", .LastName = "Alpuerto", .Age = 26, .Salary = 123499, .GrandTotal = 123495508, .PF = 88798, .ESI = 345348, .Tax = 55398, .Income = 4489, .Company = "TC", .Loss = 250, .Profit = 234423, .TrunOver = 2448193891, .Incometax = 78124, .Expense = 9879814, .Payslip = 458789, .Unitprice = 798, .Stockdetails = "Avial", .StockCount = 8966, .Count = 89})
				items.Add(New Person() With {.FirstName = "Sandra", .LastName = "Altamirano", .Age = 23, .Salary = 1999, .GrandTotal = 898908, .PF = 8798798, .ESI = 2498, .Tax = 4298, .Income = 2389, .Company = "SF", .Loss = 880, .Profit = 880980, .TrunOver = 48193891, .Incometax = 234113, .Expense = 98798798, .Payslip = 8789, .Unitprice = 987, .Stockdetails = "Avial", .StockCount = 8989, .Count = 43})
				items.Add(New Person() With {.FirstName = "Selena", .LastName = "Alvarad", .Age = 24, .Salary = 12349, .GrandTotal = 234923408, .PF = 8798798, .ESI = 423598, .Tax = 568, .Income = 289, .Company = "WP", .Loss = 450, .Profit = 54580, .TrunOver = 28193891, .Incometax = 2113, .Expense = 1798798, .Payslip = 68789, .Unitprice = 8798, .Stockdetails = "Avial", .StockCount = 4389, .Count = 83})
				items.Add(New Person() With {.FirstName = "Emilio", .LastName = "Alvaro", .Age = 26, .Salary = 123499, .GrandTotal = 123495508, .PF = 88798, .ESI = 345348, .Tax = 55398, .Income = 4489, .Company = "TC", .Loss = 250, .Profit = 234423, .TrunOver = 2448193891, .Incometax = 78124, .Expense = 9879814, .Payslip = 458789, .Unitprice = 798, .Stockdetails = "Avial", .StockCount = 8966, .Count = 89})
				items.Add(New Person() With {.FirstName = "Maxwell", .LastName = "Amland", .Age = 23, .Salary = 1999, .GrandTotal = 898908, .PF = 8798798, .ESI = 2498, .Tax = 4298, .Income = 2389, .Company = "SF", .Loss = 880, .Profit = 880980, .TrunOver = 48193891, .Incometax = 234113, .Expense = 98798798, .Payslip = 8789, .Unitprice = 987, .Stockdetails = "Avial", .StockCount = 8989, .Count = 43})
				items.Add(New Person() With {.FirstName = "Ramona", .LastName = "Antrim", .Age = 24, .Salary = 12349, .GrandTotal = 234923408, .PF = 8798798, .ESI = 423598, .Tax = 568, .Income = 289, .Company = "WP", .Loss = 450, .Profit = 54580, .TrunOver = 28193891, .Incometax = 2113, .Expense = 1798798, .Payslip = 68789, .Unitprice = 8798, .Stockdetails = "Avial", .StockCount = 4389, .Count = 83})
				items.Add(New Person() With {.FirstName = "Sabria", .LastName = "Appelbaum", .Age = 26, .Salary = 123499, .GrandTotal = 123495508, .PF = 88798, .ESI = 345348, .Tax = 55398, .Income = 4489, .Company = "TC", .Loss = 250, .Profit = 234423, .TrunOver = 2448193891, .Incometax = 78124, .Expense = 9879814, .Payslip = 458789, .Unitprice = 798, .Stockdetails = "Avial", .StockCount = 8966, .Count = 89})
				items.Add(New Person() With {.FirstName = "Hannah", .LastName = "Arakawa", .Age = 23, .Salary = 1999, .GrandTotal = 898908, .PF = 8798798, .ESI = 2498, .Tax = 4298, .Income = 2389, .Company = "SF", .Loss = 880, .Profit = 880980, .TrunOver = 48193891, .Incometax = 234113, .Expense = 98798798, .Payslip = 8789, .Unitprice = 987, .Stockdetails = "Avial", .StockCount = 8989, .Count = 43})
				items.Add(New Person() With {.FirstName = "Kyley", .LastName = "Arbelaez", .Age = 24, .Salary = 12349, .GrandTotal = 234923408, .PF = 8798798, .ESI = 423598, .Tax = 568, .Income = 289, .Company = "WP", .Loss = 450, .Profit = 54580, .TrunOver = 28193891, .Incometax = 2113, .Expense = 1798798, .Payslip = 68789, .Unitprice = 8798, .Stockdetails = "Avial", .StockCount = 4389, .Count = 83})
				items.Add(New Person() With {.FirstName = "Thomas", .LastName = "Armstrong", .Age = 26, .Salary = 123499, .GrandTotal = 123495508, .PF = 88798, .ESI = 345348, .Tax = 55398, .Income = 4489, .Company = "TC", .Loss = 250, .Profit = 234423, .TrunOver = 2448193891, .Incometax = 78124, .Expense = 9879814, .Payslip = 458789, .Unitprice = 798, .Stockdetails = "Avial", .StockCount = 8966, .Count = 89})
				items.Add(New Person() With {.FirstName = "Chris", .LastName = "Ashton", .Age = 23, .Salary = 1999, .GrandTotal = 898908, .PF = 8798798, .ESI = 2498, .Tax = 4298, .Income = 2389, .Company = "SF", .Loss = 880, .Profit = 880980, .TrunOver = 48193891, .Incometax = 234113, .Expense = 98798798, .Payslip = 8789, .Unitprice = 987, .Stockdetails = "Avial", .StockCount = 8989, .Count = 43})
				items.Add(New Person() With {.FirstName = "Teresa", .LastName = "Atkinson", .Age = 24, .Salary = 12349, .GrandTotal = 234923408, .PF = 8798798, .ESI = 423598, .Tax = 568, .Income = 289, .Company = "WP", .Loss = 450, .Profit = 54580, .TrunOver = 28193891, .Incometax = 2113, .Expense = 1798798, .Payslip = 68789, .Unitprice = 8798, .Stockdetails = "Avial", .StockCount = 4389, .Count = 83})
				items.Add(New Person() With {.FirstName = "Robert", .LastName = "Avalos", .Age = 26, .Salary = 123499, .GrandTotal = 123495508, .PF = 88798, .ESI = 345348, .Tax = 55398, .Income = 4489, .Company = "TC", .Loss = 250, .Profit = 234423, .TrunOver = 2448193891, .Incometax = 78124, .Expense = 9879814, .Payslip = 458789, .Unitprice = 798, .Stockdetails = "Avial", .StockCount = 8966, .Count = 89})
			End If
			Return items

		End Function
		Public Sub UpdateSummary()
			'if(SelectedItem.Count==1)
			'    Summary = string.Format("{0} item  selected.", _selectedItem.Count);
			'else
			'    Summary = string.Format("{0} items are selected.", _selectedItem.Count);
		End Sub
		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
		Public Sub RaisePropertyChanged(ByVal propName As String)
			If Me.PropertyChangedEvent IsNot Nothing Then
				RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propName))
			End If
		End Sub
	End Class
End Namespace
